Imports System.Runtime.InteropServices
Imports System.Threading
Public Class Form1

    Private szFullName As String = Nothing
    Public Class PowerAPI
        <DllImport("coredll.dll", SetLastError:=True)> _
        Public Shared Function SetDevicePower(ByVal pvDevice As String, ByVal dwDeviceFlags As Integer, ByVal DeviceState As DevicePowerState) As Integer
        End Function

        <DllImport("coredll.dll", SetLastError:=True)> _
        Public Shared Function GetDevicePower(ByVal pvDevice As String, ByVal dwDeviceFlags As Integer, ByRef DeviceState As DevicePowerState) As Integer
        End Function

        <DllImport("coredll.dll", SetLastError:=True)> _
        Public Shared Function DevicePowerNotify(ByVal device As String, ByVal state As DevicePowerState, ByVal flags As Integer) As Integer
        End Function

        Public Enum DevicePowerState As Integer

            Unspecified = -1

            D0 = 0 ' Full On: full power, full functionality

            D1 ' Low Power On: fully functional at low power/performance

            D2 ' Standby: partially powered with automatic wake

            D3 ' Sleep: partially powered with device initiated wake

            D4 ' Off: unpowered

        End Enum
    End Class
    Public POWER_NAME As Integer = 1
    Public ERROR_SUCCESS As Integer = 0
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        szFullName = "{EB91C7C9-8BF6-4a2d-9AB8-69724EED97D1}\\Windows\ddi.dll"
    End Sub

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        szFullName = "{EB91C7C9-8BF6-4a2d-9AB8-69724EED97D1}\\Windows\ddi.dll"
    End Sub

    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
        szFullName = "{EB91C7C9-8BF6-4a2d-9AB8-69724EED97D1}\\Windows\ddi_mq200.dll"
    End Sub
    Dim IdleState As Boolean = False
    Private Sub button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button3.Click
        szFullName = "BKL1:"
        IdleState = True
    End Sub
    Private Sub GetPowerstate()
        Dim cepower As New PowerAPI.DevicePowerState()
        If PowerAPI.GetDevicePower(szFullName, POWER_NAME, cepower) = ERROR_SUCCESS Then
            If cepower = PowerAPI.DevicePowerState.D0 Then
                Console.WriteLine("Power state for is D0")
            ElseIf cepower = PowerAPI.DevicePowerState.D1 Then
                Console.WriteLine("Power state for is D1")
            ElseIf cepower = PowerAPI.DevicePowerState.D2 Then
                Console.WriteLine("Power state for is D2")
            ElseIf cepower = PowerAPI.DevicePowerState.D3 Then
                Console.WriteLine("Power state for is D3")
            ElseIf cepower = PowerAPI.DevicePowerState.D4 Then
                Console.WriteLine("Power state for is D4")
            Else
                Console.WriteLine("Power state for " & szFullName & " isn't defined")
            End If
        Else
            Console.WriteLine("GetDevicePower(" & szFullName & ") was unsuccessful")
        End If
    End Sub
    Private Sub button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button4.Click
        GetPowerstate()
        Thread.Sleep(1000)
        Console.WriteLine("/////////////D4///////////")
        PowerAPI.SetDevicePower(szFullName, POWER_NAME, PowerAPI.DevicePowerState.D4) 'Set suspend state
        Thread.Sleep(1000)
        GetPowerstate()
        Console.WriteLine("/////////////D0///////////")
        PowerAPI.SetDevicePower(szFullName, POWER_NAME, PowerAPI.DevicePowerState.D0)
        GetPowerstate()
        Console.WriteLine("//////////////////////////")

        If IdleState Then
            Thread.Sleep(1000)
            Console.WriteLine("/////////////D3///////////")
            PowerAPI.SetDevicePower(szFullName, POWER_NAME, PowerAPI.DevicePowerState.D3) 'Set idle state
            Thread.Sleep(1000)
            GetPowerstate()
            Console.WriteLine("/////////////D0///////////")
            PowerAPI.SetDevicePower(szFullName, POWER_NAME, PowerAPI.DevicePowerState.D0)
            GetPowerstate()
            Console.WriteLine("//////////////////////////")
        End If
    End Sub

    Private Sub button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button5.Click
        GetPowerstate()
    End Sub
End Class
